﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using System.Runtime.InteropServices;


namespace NbtRobot
{
    public partial class Form1 : Form
    {
        public NbtRobot mRobot;
        private Nrc.CALLBACK callback;
        public Form1()
        {
            InitializeComponent();
            callback = this.Msg;
            Nrc.setErrorHandle(callback);
        }

        private void btn_conn_rob_Click(object sender, EventArgs e)
        {
            string IP = "192.168.1.13";
            if (mRobot == null)
            { 
                mRobot = new NbtRobot(IP);
            }
            else
            {
                if (Nrc.connect_robot(IP))
                {
                    Console.WriteLine("Length:");
                    Debug.WriteLine("连接成功");
                }
                else
                {
                    Debug.WriteLine("连接失败");
                }
            }
        }

        private void btn_servo_on_Click(object sender, EventArgs e)
        {
            mRobot.servo_power_on();
        }

        private void btn_power_off_Click(object sender, EventArgs e)
        {
            mRobot.servo_power_off();
        }

        private void btn_get_pos_Click(object sender, EventArgs e)
        {
            double[] d = new double[6];
            mRobot.get_current_position(d,0);
            for(int i = 0; i < 6; i++)
            {
                Debug.WriteLine(d[i]);
            }            
        }

        private void btn_move_j_Click(object sender, EventArgs e)
        {
            double[] d = new double[6];
            mRobot.get_current_position(d,0);

            for (int i = 0; i < 6; i++)
            {
                d[i] += 1;
            }

            JointPos pos = new JointPos(d);

            mRobot.MovJ(pos,10,0);
        }

        System.Timers.Timer timer_n_1 = new System.Timers.Timer();

        private void btn_jog_axis_n_1_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_1.Enabled = true;
            timer_n_1.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_1.Start();
            timer_n_1.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_1_Elapsed);
        }

        private void timer_n_1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(1);
        }

        private void btn_jog_axis_n_1_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_1.Stop();
            mRobot.stop_jogging(1);
        }

        System.Timers.Timer timer_p_1 = new System.Timers.Timer();

        private void btn_jog_axis_p_1_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_1.Enabled = true;
            timer_p_1.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_1.Start();
            timer_p_1.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_1_Elapsed);
        }

        private void timer_p_1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(1);
        }

        private void btn_jog_axis_p_1_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_1.Stop();
            mRobot.stop_jogging(1);
        }

        System.Timers.Timer timer_n_2 = new System.Timers.Timer();

        private void btn_jog_axis_n_2_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_2.Enabled = true;
            timer_n_2.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_2.Start();
            timer_n_2.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_2_Elapsed);
        }

        private void timer_n_2_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(2);
        }

        private void btn_jog_axis_n_2_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_2.Stop();
            mRobot.stop_jogging(2);
        }

        System.Timers.Timer timer_p_2 = new System.Timers.Timer();
        private void btn_jog_axis_p_2_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_2.Enabled = true;
            timer_p_2.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_2.Start();
            timer_p_2.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_2_Elapsed);
        }

        private void timer_p_2_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(2);
        }

        private void btn_jog_axis_p_2_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_2.Stop();
            mRobot.stop_jogging(2);
        }

        System.Timers.Timer timer_n_3 = new System.Timers.Timer();
        private void btn_jog_axis_n_3_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_3.Enabled = true;
            timer_n_3.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_3.Start();
            timer_n_3.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_3_Elapsed);
        }

        private void timer_n_3_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(3);
        }

        private void btn_jog_axis_n_3_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_3.Stop();
            mRobot.stop_jogging(3);
        }

        System.Timers.Timer timer_p_3 = new System.Timers.Timer();
        private void btn_jog_axis_p_3_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_3.Enabled = true;
            timer_p_3.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_3.Start();
            timer_p_3.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_3_Elapsed);
        }

        private void timer_p_3_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(3);
        }

        private void btn_jog_axis_p_3_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_3.Stop();
            mRobot.stop_jogging(3);
        }

        System.Timers.Timer timer_n_4 = new System.Timers.Timer();
        private void btn_jog_axis_n_4_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_4.Enabled = true;
            timer_n_4.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_4.Start();
            timer_n_4.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_4_Elapsed);
        }

        private void timer_n_4_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(4);
        }
        private void btn_jog_axis_n_4_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_4.Stop();
            mRobot.stop_jogging(4);
        }

        System.Timers.Timer timer_p_4 = new System.Timers.Timer();
        private void btn_jog_axis_p_4_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_4.Enabled = true;
            timer_p_4.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_4.Start();
            timer_p_4.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_4_Elapsed);
        }

        private void timer_p_4_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(4);
        }
        private void btn_jog_axis_p_4_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_4.Stop();
            mRobot.stop_jogging(4);
        }

        System.Timers.Timer timer_n_5 = new System.Timers.Timer();
        private void btn_jog_axis_n_5_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_5.Enabled = true;
            timer_n_5.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_5.Start();
            timer_n_5.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_5_Elapsed);
        }

        private void timer_n_5_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(5);
        }
        private void btn_jog_axis_n_5_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_5.Stop();
            mRobot.stop_jogging(5);
        }

        System.Timers.Timer timer_p_5 = new System.Timers.Timer();
        private void btn_jog_axis_p_5_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_5.Enabled = true;
            timer_p_5.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_5.Start();
            timer_p_5.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_5_Elapsed);
        }
        private void timer_p_5_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(5);
        }
        private void btn_jog_axis_p_5_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_5.Stop();
            mRobot.stop_jogging(5);
        }

        System.Timers.Timer timer_n_6 = new System.Timers.Timer();
        private void btn_jog_axis_n_6_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_6.Enabled = true;
            timer_n_6.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_6.Start();
            timer_n_6.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_6_Elapsed);
        }
        private void timer_n_6_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(6);
        }
        private void btn_jog_axis_n_6_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_6.Stop();
            mRobot.stop_jogging(6);
        }

        System.Timers.Timer timer_p_6 = new System.Timers.Timer();
        private void btn_jog_axis_p_6_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_6.Enabled = true;
            timer_p_6.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_6.Start();
            timer_p_6.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_6_Elapsed);
        }
        private void timer_p_6_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(6);
        }
        private void btn_jog_axis_p_6_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_6.Stop();
            mRobot.stop_jogging(6);
        }

        private void btn_move_l_Click(object sender, EventArgs e)
        {
            double[] d = new double[6];
            mRobot.get_current_position(d,0);

            for (int i = 0; i < 6; i++)
            {
                d[i] += 1;
            }

            JointPos pos = new JointPos(d);

            mRobot.MovL(pos,10,0);
        }

        private void btn_get_status_Click(object sender, EventArgs e)
        {
            int state = mRobot.get_robot_state();
            Debug.WriteLine(state);
        }

        private void btn_set_speed_Click(object sender, EventArgs e)
        {
            mRobot.set_jogging_speed(50);
        }

        private void btn_get_IO_Click(object sender, EventArgs e)
        {
            double[] din = new double[16];
            double[] dout = new double[16];
            double[] ain = new double[16];
            double[] aout = new double[16];
            mRobot.get_din(din);
            mRobot.get_dout(dout);
            mRobot.get_ain(ain);
            mRobot.get_aout(aout);
        }

        private void btn_set_dout_Click(object sender, EventArgs e)
        {
            mRobot.set_dout(1, 1);
        }

        private void btn_set_aout_Click(object sender, EventArgs e)
        {
            mRobot.set_aout(1, 1);
        }

        private void btn_motion_mode_on_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_mode(1);
        }

        private void btn_motion_mode_off_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_mode(0);
        }

        public void btn_send_queue_Click(object sender, EventArgs e)
        {
            Nrc.cmdPara[] cmd = new Nrc.cmdPara[5] { new Nrc.cmdPara(), new Nrc.cmdPara(), new Nrc.cmdPara(), new Nrc.cmdPara(), new Nrc.cmdPara() };

            cmd[0].cmdType = Nrc.cmdPara.Type.MOVJ;
            cmd[0].m_velocity = 50;
            cmd[0].m_acc = 50;
            cmd[0].m_dec = 50;
            cmd[0].m_pl = 1;
            cmd[0].m_coord = new double[7];
            cmd[0].m_coord[0] = 0;
            cmd[0].m_coord[1] = 0;
            cmd[0].m_coord[2] = 0;
            cmd[0].m_coord[3] = 0;
            cmd[0].m_coord[4] = 0;
            cmd[0].m_coord[5] = 0;
            cmd[0].m_coord[6] = 0;
            cmd[0].m_position = new double[7];
            cmd[0].m_position[0] = 0;
            cmd[0].m_position[1] = 0;
            cmd[0].m_position[2] = 0;
            cmd[0].m_position[3] = 0;
            cmd[0].m_position[4] = 0;
            cmd[0].m_position[5] = 0;
            cmd[0].m_position[6] = 0;

            cmd[1].cmdType = Nrc.cmdPara.Type.MOVJ;
            cmd[1].m_velocity = 50;
            cmd[1].m_acc = 50;
            cmd[1].m_dec = 50;
            cmd[1].m_pl = 1;
            cmd[1].m_coord = new double[7];
            cmd[1].m_coord[0] = 0;
            cmd[1].m_coord[1] = 0;
            cmd[1].m_coord[2] = 0;
            cmd[1].m_coord[3] = 0;
            cmd[1].m_coord[4] = 0;
            cmd[1].m_coord[5] = 0;
            cmd[1].m_coord[6] = 0;
            cmd[1].m_position = new double[7];
            cmd[1].m_position[0] = 5;
            cmd[1].m_position[1] = 5;
            cmd[1].m_position[2] = 5;
            cmd[1].m_position[3] = 5;
            cmd[1].m_position[4] = 5;
            cmd[1].m_position[5] = 5;
            cmd[1].m_position[6] = 5;

            cmd[2].cmdType = Nrc.cmdPara.Type.MOVJ;
            cmd[2].m_velocity = 50;
            cmd[2].m_acc = 50;
            cmd[2].m_dec = 50;
            cmd[2].m_pl = 1;
            cmd[2].m_coord = new double[7];
            cmd[2].m_coord[0] = 0;
            cmd[2].m_coord[1] = 0;
            cmd[2].m_coord[2] = 0;
            cmd[2].m_coord[3] = 0;
            cmd[2].m_coord[4] = 0;
            cmd[2].m_coord[5] = 0;
            cmd[2].m_coord[6] = 0;
            cmd[2].m_position = new double[7];
            cmd[2].m_position[0] = 5;
            cmd[2].m_position[1] = 5;
            cmd[2].m_position[2] = 5;
            cmd[2].m_position[3] = 5;
            cmd[2].m_position[4] = 5;
            cmd[2].m_position[5] = 5;
            cmd[2].m_position[6] = 5;

            cmd[3].cmdType = Nrc.cmdPara.Type.MOVCA;
            cmd[3].m_velocity = 50;
            cmd[3].m_acc = 50;
            cmd[3].m_dec = 50;
            cmd[3].m_pl = 1;
            cmd[3].m_coord = new double[7];
            cmd[3].m_coord[0] = 0;
            cmd[3].m_coord[1] = 0;
            cmd[3].m_coord[2] = 0;
            cmd[3].m_coord[3] = 0;
            cmd[3].m_coord[4] = 0;
            cmd[3].m_coord[5] = 0;
            cmd[3].m_coord[6] = 0;
            cmd[3].m_position = new double[7];
            cmd[3].m_position[0] = 5;
            cmd[3].m_position[1] = 5;
            cmd[3].m_position[2] = 5;
            cmd[3].m_position[3] = 5;
            cmd[3].m_position[4] = 5;
            cmd[3].m_position[5] = 5;
            cmd[3].m_position[6] = 5;

            cmd[4].cmdType = Nrc.cmdPara.Type.MOVCA;
            cmd[4].m_velocity = 50;
            cmd[4].m_acc = 50;
            cmd[4].m_dec = 50;
            cmd[4].m_pl = 1;
            cmd[4].m_coord = new double[7];
            cmd[4].m_coord[0] = 0;
            cmd[4].m_coord[1] = 0;
            cmd[4].m_coord[2] = 0;
            cmd[4].m_coord[3] = 0;
            cmd[4].m_coord[4] = 0;
            cmd[4].m_coord[5] = 0;
            cmd[4].m_coord[6] = 0;
            cmd[4].m_position = new double[7];
            cmd[4].m_position[0] = 5;
            cmd[4].m_position[1] = 5;
            cmd[4].m_position[2] = 5;
            cmd[4].m_position[3] = 5;
            cmd[4].m_position[4] = 5;
            cmd[4].m_position[5] = 5;
            cmd[4].m_position[6] = 5;
            
            mRobot.send_continuous_motion_queue(cmd,5);
        }

        private void btn_move_c_Click(object sender, EventArgs e)
        {
            double[] pos1 = new double[6];
            double[] pos2 = new double[6];
            double[] pos3 = new double[6];
            mRobot.get_current_position(pos1,0);

            for (int i = 0; i < 6; i++)
            {
                pos1[i] += 1;

                pos2[i] += pos1[i]+5;

                pos3[i] += pos2[i]+10;
            }

            mRobot.MovC(pos1, pos2,pos3, 10, 0);
        }

        private void btn_move_ca_Click(object sender, EventArgs e)
        {
            double[] pos1 = new double[6];
            double[] pos2 = new double[6];
            double[] pos3 = new double[6];
            mRobot.get_current_position(pos1,0);

            for (int i = 0; i < 6; i++)
            {
                pos1[i] += 1;

                pos2[i] += pos1[i] + 5;

                pos3[i] += pos2[i] + 10;
            }

            mRobot.MovCA(pos1, pos2, pos3, 10, 0);
        }

        private void btn_upload_job_Click(object sender, EventArgs e)
        {
            mRobot.upload_job();
        }

        private void btn_set_mode_Click(object sender, EventArgs e)
        {
            mRobot.set_mode(0);
        }

        private void btn_get_mode_Click(object sender, EventArgs e)
        {
            int mode = mRobot.get_mode();
            Debug.WriteLine(mode);
        }

        private void btn_set_coord_Click(object sender, EventArgs e)
        {
            mRobot.set_coord(1);
        }

        private void btn_get_coord_Click(object sender, EventArgs e)
        {
            int coord = mRobot.get_coord();
            Debug.WriteLine(coord);
        }

        private void btn_get_speed_Click(object sender, EventArgs e)
        {
            int speed = mRobot.get_jogging_speed();
            Debug.WriteLine(speed);
        }

        private void btn_start_Click(object sender, EventArgs e)
        {
            string file = "TEST";
            int mode = mRobot.get_mode();
            if (mode != 2)
            {
                Debug.WriteLine("运行只能在运行模式下执行");
                return;
            }
            mRobot.run_job(file);
            Debug.WriteLine("开始运行作业文件：" + file);
        }
        private void btn_open_Click(object sender, EventArgs e)
        {
            int mode = mRobot.get_mode();
            if (mode == 2)
            {
                Debug.WriteLine("运行模式无法打开作业文件");
                return;
            }
            mRobot.open_job("TEST");
        }

        private void btn_step_Click(object sender, EventArgs e)
        {
            int mode = mRobot.get_mode();
            if (mode != 0)
            {
                Debug.WriteLine("单步运行只能在示教模式下执行");
                return;
            }
            mRobot.step_job("TEST",2);
        }


        System.Timers.Timer timer_n_8 = new System.Timers.Timer();

        private void btn_jog_sync_n_1_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_8.Enabled = true;
            timer_n_8.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_8.Start();
            timer_n_8.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_8_Elapsed);
        }

        private void timer_n_8_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(8);
        }

        private void btn_jog_sync_n_1_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_8.Stop();
            mRobot.stop_jogging(8);
        }

        System.Timers.Timer timer_p_8 = new System.Timers.Timer();
        private void btn_jog_sync_p_1_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_8.Enabled = true;
            timer_p_8.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_8.Start();
            timer_p_8.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_8_Elapsed);
        }

        private void timer_p_8_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(8);
        }
        private void btn_jog_sync_p_1_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_8.Stop();
            mRobot.stop_jogging(8);
        }

        System.Timers.Timer timer_n_9 = new System.Timers.Timer();
        private void btn_jog_sync_n_2_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_9.Enabled = true;
            timer_n_9.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_9.Start();
            timer_n_9.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_9_Elapsed);
        }

        private void timer_n_9_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(9);
        }

        private void btn_jog_sync_n_2_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_9.Stop();
            mRobot.stop_jogging(9);
        }

        System.Timers.Timer timer_p_9 = new System.Timers.Timer();
        private void btn_jog_sync_p_2_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_9.Enabled = true;
            timer_p_9.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_9.Start();
            timer_p_9.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_9_Elapsed);
        }

        private void timer_p_9_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(9);
        }

        private void btn_jog_sync_p_2_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_9.Stop();
            mRobot.stop_jogging(9);
        }

        System.Timers.Timer timer_n_10 = new System.Timers.Timer();
        private void btn_jog_sync_n_3_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_10.Enabled = true;
            timer_n_10.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_10.Start();
            timer_n_10.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_10_Elapsed);
        }

        private void timer_n_10_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(10);
        }

        private void btn_jog_sync_n_3_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_10.Stop();
            mRobot.stop_jogging(10);
        }

        System.Timers.Timer timer_p_10 = new System.Timers.Timer();
        private void btn_jog_sync_p_3_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_10.Enabled = true;
            timer_p_10.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_10.Start();
            timer_p_10.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_10_Elapsed);
        }

        private void timer_p_10_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(10);
        }

        private void btn_jog_sync_p_3_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_10.Stop();
            mRobot.stop_jogging(10);
        }

        System.Timers.Timer timer_n_11 = new System.Timers.Timer();
        private void btn_jog_sync_n_4_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_11.Enabled = true;
            timer_n_11.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_11.Start();
            timer_n_11.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_11_Elapsed);
        }

        private void timer_n_11_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(11);
        }

        private void btn_jog_sync_n_4_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_11.Stop();
            mRobot.stop_jogging(11);
        }

        System.Timers.Timer timer_p_11 = new System.Timers.Timer();
        private void btn_jog_sync_p_4_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_11.Enabled = true;
            timer_p_11.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_11.Start();
            timer_p_11.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_11_Elapsed);
        }

        private void timer_p_11_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(11);
        }

        private void btn_jog_sync_p_4_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_11.Stop();
            mRobot.stop_jogging(11);
        }

        System.Timers.Timer timer_n_12 = new System.Timers.Timer();
        private void btn_jog_sync_n_5_MouseDown(object sender, MouseEventArgs e)
        {
            timer_n_12.Enabled = true;
            timer_n_12.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_n_12.Start();
            timer_n_12.Elapsed += new System.Timers.ElapsedEventHandler(timer_n_12_Elapsed);
        }

        private void timer_n_12_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_n(12);
        }

        private void btn_jog_sync_n_5_MouseUp(object sender, MouseEventArgs e)
        {
            timer_n_12.Stop();
            mRobot.stop_jogging(12);
        }

        System.Timers.Timer timer_p_12 = new System.Timers.Timer();
        private void btn_jog_sync_p_5_MouseDown(object sender, MouseEventArgs e)
        {
            timer_p_12.Enabled = true;
            timer_p_12.Interval = 200;//执行间隔时间,单位为毫秒    
            timer_p_12.Start();
            timer_p_12.Elapsed += new System.Timers.ElapsedEventHandler(timer_p_12_Elapsed);
        }

        private void timer_p_12_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mRobot.start_jogging_p(12);
        }

        private void btn_jog_sync_p_5_MouseUp(object sender, MouseEventArgs e)
        {
            timer_p_12.Stop();
            mRobot.stop_jogging(12);
        }

        private void btn_get_sync_pos_Click(object sender, EventArgs e)
        {
            double[] d = new double[5];
            mRobot.get_current_sync_position(d);
            for (int i = 0; i < 5; i++)
            {
                Debug.WriteLine(d[i]);
            }
        }

        private void btn_stop_Click(object sender, EventArgs e)
        {
            mRobot.pause_job();
        }

        private void btn_mark_Click(object sender, EventArgs e)
        {
            mRobot.four_point_mark(0, 1);
            mRobot.four_point_mark(1, 1);
            mRobot.four_point_mark(2, 1);
            mRobot.four_point_mark(3, 1);
        }

        private void btn_calculation_Click(object sender, EventArgs e)
        {
            double[] result = new double[5];
            mRobot.four_point_calculation(200, 150, result);
            for (int i = 0; i < 5; i++)
            {
                Debug.WriteLine(result[i]);
            }
        }

        private void btn_result_dh_Click(object sender, EventArgs e)
        {
            mRobot.result_for_DH();
        }

        private void btn_get_four_Click(object sender, EventArgs e)
        {
            double[] result = new double[9];
            mRobot.ask_four_point(result);
            for (int i = 0; i < 9; i++)
            {
                Debug.WriteLine(result[i]);
            }
        }

        private void btn_download_job_Click(object sender, EventArgs e)
        {
            mRobot.download_job();
        }

        private void btn_set_runs_Click(object sender, EventArgs e)
        {
            mRobot.set_runs(0);
        }

        private void btn_extra_movj_Click(object sender, EventArgs e)
        {
            double[] pos = new double[12];
            for (int i = 0; i < 12; i++)
            {
                pos[i] = 1;
            }
            mRobot.ExtraMovJ(pos, 10, 0);
        }

        private void btn_extra_movl_Click(object sender, EventArgs e)
        {
            double[] pos = new double[12];
            for (int i = 0; i < 12; i++)
            {
                pos[i] = 10;
            }
            mRobot.ExtraMovL(pos, 10, 0);
        }

        private void btn_extra_movc_Click(object sender, EventArgs e)
        {
            double[] pos1 = new double[12];
            double[] pos2 = new double[12];
            double[] pos3 = new double[12];

            for (int i = 0; i < 12; i++)
            {
                pos1[i] = 5;

                pos2[i] = pos1[i] + 5;

                pos3[i] = pos2[i] + 10;
            }

            mRobot.ExtraMovC(pos1, pos2, pos3, 10, 0);
        }


        private void btn_delete_job_Click(object sender, EventArgs e)
        {
            mRobot.delete_job("MOVS");
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void btn_connection_status_Click(object sender, EventArgs e)
        {
            mRobot.get_connection_status();
        }

        private void btn_motion_mode_start_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_start();
        }

        private void btn_motion_mode_suspend_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_suspend();
        }

        private void btn_motion_mode_stop_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_stop();
        }

        private void btn_get_servo_state_Click(object sender, EventArgs e)
        {
            int state = mRobot.get_servo_state();
            Debug.WriteLine(state);
        }

        private void btn_clear_servo_err_Click(object sender, EventArgs e)
        {
            int mode = mRobot.get_mode();
            if (mode == 2)
            {
                Debug.WriteLine("运行模式无法清错");
                return;
            }
            mRobot.clear_servo_error();
            Debug.WriteLine("伺服错误已清除");
        }

        private void btn_set_zero_Click(object sender, EventArgs e)
        {
            mRobot.set_zero(0);
        }

        private void btn_get_var_Click(object sender, EventArgs e)
        {
            double I = mRobot.get_global_variant("GI001");
            Debug.WriteLine(I);
        }

        private void btn_set_var_Click(object sender, EventArgs e)
        {
            mRobot.set_global_variant("GI001",5);
        }

        private void set_zero_pos_shift_Click(object sender, EventArgs e)
        {
            mRobot.set_zero_pos_shift(1,50);
        }

        private void get_single_cycle_Click(object sender, EventArgs e)
        {
            double[] singleCycle = new double [6];
            mRobot.get_single_cycle(singleCycle);
            for (int i = 0; i < 6; i++)
            {
                Debug.WriteLine(singleCycle[i]);
            }
        }
        public void Msg(IntPtr msg)
        {
            byte[] bytes = System.Text.Encoding.Unicode.GetBytes(Marshal.PtrToStringUni(msg));//转成UNICODE编码
            string dec = System.Text.Encoding.UTF8.GetString(bytes,0,bytes.Length);
            string[] m = dec.Split('\0');
            Debug.WriteLine(m[0]);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (mRobot == null)
            {
                return;
            }
            mRobot.show_log();    
        }

        private void btn_set_run_mode_Click(object sender, EventArgs e)
        {
            mRobot.set_mode(2);
        }

        private void btn_set_servo_state_Click(object sender, EventArgs e)
        {
            //1代表设置伺服就绪
            mRobot.set_servo_state(1);
        }

        private void btn_continue_run_Click(object sender, EventArgs e)
        {
            mRobot.continue_run();
        }

        private void btn_continue_job_Click(object sender, EventArgs e)
        {
            mRobot.continue_job();
        }

        private void continuous_motion_start_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_start();
        }

        private void continuous_motion_pause_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_suspend();
        }

        private void continuous_motion_stop_Click(object sender, EventArgs e)
        {
            mRobot.continuous_motion_stop();
        }
    }
}
