﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace NbtRobot
{
    public class NbtRobot
    {
        private string IP;
        public bool jog;

        public NbtRobot(string ip)
        {
            this.IP = ip;
            Debug.WriteLine("连接中");
            if (Nrc.connect_robot(IP))
            {
                Debug.WriteLine("连接成功");
            }
}

        public void get_connection_status()
        {
            if (Nrc.connection_status())
            {
                Debug.WriteLine("已连接");
            }
            else
            {
                Debug.WriteLine("连接断开");
            }
        }
        public void set_servo_state(int state)
        {
            Nrc.set_servo_state(state);
        }
        public int get_servo_state()
        {
            return Nrc.get_servo_state();
        }

        public void clear_servo_error()
        {
            Nrc.clear_servo_error();
        }

        public void set_zero(int axis)
        {
            Nrc.set_axis_zero(axis);
        }

        public double get_global_variant(string var)
        {
            return Nrc.get_global_variant(var);
        }

        public void set_global_variant(string var, double varValue)
        {
            Nrc.set_global_variant(var, varValue);
        }

        public void servo_power_on()
        {
            if (Nrc.servo_power_on())
            {

            }
        }

        public void servo_power_off()
        {
            Nrc.servo_power_off();
        }

        public void start_jogging_n(int axis)
        {
            Nrc.start_jogging(axis, false);
        }

        public void start_jogging_p(int axis)
        {
            Nrc.start_jogging(axis, true);
        }

        public void stop_jogging(int axis)
        {
            Nrc.stop_jogging(axis);
        }

        public void get_current_position(double[] d, int coord)
        {
            Nrc.get_current_position(d, coord);
        }

        public void get_current_sync_position(double[] d)
        {
            Nrc.get_current_sync_position(d);
        }

        public int get_robot_state()
        {
            return Nrc.get_robot_running_state();
        }

        public void set_jogging_speed(int speed)
        {
            Nrc.set_jogging_speed(speed);
        }

        public int get_jogging_speed()
        {
            return Nrc.get_jogging_speed();
        }

        public void set_dout(int port, int value)
        {
            Nrc.set_dout(port, value);
        }

        public void set_aout(int port, double value)
        {
            Nrc.set_aout(port, value);
        }

        public void get_dout(double[] dout)
        {
            Nrc.get_dout(dout);
        }

        public void get_din(double[] din)
        {
            Nrc.get_din(din);
        }

        public void get_aout(double[] aout)
        {
            Nrc.get_aout(aout);
        }

        public void get_ain(double[] ain)
        {
            Nrc.get_ain(ain);
        }

        public void continuous_motion_mode(int on)
        {
            Nrc.continuous_motion_mode(on);
        }

        public void continuous_motion_start()
        {
            Nrc.continuous_motion_start();
        }

        public void continuous_motion_suspend()
        {
            Nrc.continuous_motion_suspend();
        }

        public void continuous_motion_stop()
        {
            Nrc.continuous_motion_stop();
        }

        public void send_continuous_motion_queue(Nrc.cmdPara[] cmd, int size)
        {
            for (int i = 0; i < size; i++)
            {
                Console.WriteLine("aaaaaaa" + cmd[i].cmdType);
            }
            
            Nrc.send_continuous_motion_queue(cmd, size);
        }

        public bool MovJ(JointPos pos, int vel, int coord)
        {
            Nrc.robot_movj(pos.TranArray(), vel, coord);
            return true;
        }

        public bool MovL(JointPos pos, int vel, int coord)
        {
            Nrc.robot_movl(pos.TranArray(), vel, coord);
            return true;
        }

        public bool MovC(double[] pos1, double[] pos2, double[] pos3, int vel, int coord)
        {
            Nrc.robot_movc(pos1, pos2, pos3, vel, coord);
            return true;
        }

        public bool MovCA(double[] pos1, double[] pos2, double[] pos3, int vel, int coord)
        {
            Nrc.robot_movca(pos1, pos2, pos3, vel, coord);
            return true;
        }

        public bool MovS(int size, double[][] pos, int vel, int coord)
        {
            Nrc.robot_movs(size, pos, vel, coord);
            return true;
        }

        public bool ExtraMovJ(double[] pos1, int vel, int coord)
        {
            Nrc.robot_extra_movj(pos1, vel, coord);
            return true;
        }

        public bool ExtraMovL(double[] pos1, int vel, int coord)
        {
            Nrc.robot_extra_movl(pos1, vel, coord);
            return true;
        }

        public bool ExtraMovC(double[] pos1, double[] pos2, double[] pos3, int vel, int coord)
        {
            Nrc.robot_extra_movc(pos1, pos2, pos3, vel, coord);
            return true;
        }

        public void upload_job()
        {
            Nrc.upload_job();
        }

        public void download_job()
        {
            Nrc.download_job();
        }

        public int get_mode()
        {
            return Nrc.get_current_mode();
        }

        public void set_mode(int mode)
        {
            Nrc.set_current_mode(mode);
            int currentmode = Nrc.get_current_mode();
            if (currentmode == 0)
            {
                Debug.WriteLine("当前模式为：示教模式");
            }
            else if (currentmode == 2)
            {
                Debug.WriteLine("当前模式为：运行模式");
            }

        }

        public int get_coord()
        {
            return Nrc.get_current_coord();
        }

        public void set_coord(int coord)
        {
            Nrc.set_current_coord(coord);
        }

        public void get_log()
        {
            IntPtr p = Nrc.show_log();
            string str_out = Marshal.PtrToStringAnsi(p);
            Console.WriteLine(str_out);
        }

        public void delete_job(string job)
        {
            Nrc.delete_job(job);
        }

        public void open_job(string job)
        {
            Nrc.open_job(job);
        }

        public void step_job(string job, int line)
        {
            Nrc.step_job(job, line);
        }

        public void run_job(string job)
        {
            Nrc.run_job(job);
        }

        public void pause_job()
        {
            Nrc.pause_job();
        }

        public void continue_job()
        {
            Nrc.continue_job();
        }

        public void continue_run()
        {
            Nrc.continue_run();
        }

        public void set_runs(int num)
        {
            Nrc.set_runs(num);
        }

        public void ask_four_point(double[] result)
        {
            Nrc.ask_four_point(result);
        }

        public void four_point_mark(int point, int status)
        {
            Nrc.four_point_mark(point, status);
        }

        public void four_point_calculation(double L1, double L2, double[] result)
        {
            Nrc.four_point_calculation(L1, L2, result);
        }

        public void result_for_DH()
        {
            if (Nrc.result_for_DH())
            {
                Debug.WriteLine("写入成功");
            }
        }

        public void get_single_cycle(double[] d)
        {
            Nrc.get_single_cycle(d);
        }

        public void set_zero_pos_shift(int axis, double shift)
        {
            Nrc.set_zero_pos_shift(axis, shift);
        }

        public void show_log()
        {
            IntPtr pRet = Nrc.show_log();
            byte[] bytes = System.Text.Encoding.Unicode.GetBytes(Marshal.PtrToStringUni(pRet));//转成UNICODE编码
            byte[] byte2 = Encoding.Convert(Encoding.UTF8, Encoding.Default, bytes, 0, bytes.Length);
            string dec = System.Text.Encoding.Default.GetString(byte2, 0, byte2.Length);
            string[] msg = dec.Split('\0');
            Debug.WriteLine(msg[0]);
        }

    }

    public class JointPos
    {
        public JointPos() { }

        public JointPos(double[] arr)
        {
            if (arr.Length < 6) return;
            this.J1 = arr[0];
            this.J2 = arr[1];
            this.J3 = arr[2];
            this.J4 = arr[3];
            this.J5 = arr[4];
            this.J6 = arr[5];
        }
        public JointPos(double j1, double j2, double j3, double j4, double j5, double j6)
        {
            this.J1 = j1;
            this.J2 = j2;
            this.J3 = j3;
            this.J4 = j4;
            this.J5 = j5;
            this.J6 = j6;
        }
        public double J1 = 0;
        public double J2 = 0;
        public double J3 = 0;
        public double J4 = 0;
        public double J5 = 0;
        public double J6 = 0;

        public double[] TranArray()
        {
            return new double[6] { this.J1, this.J2, this.J3, this.J4, this.J5, this.J6 };
        }

        public int[] TranArray(int precision)
        {
            return new int[6] { (int)(this.J1 * (Math.Pow(10, precision))), (int)(this.J2 * (Math.Pow(10, precision))), (int)(this.J3 * (Math.Pow(10, precision))), (int)(this.J4 * (Math.Pow(10, precision))), (int)(this.J5 * (Math.Pow(10, precision))), (int)(this.J6 * (Math.Pow(10, precision))) };
        }
    }
}
