﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;   //必须添加，不然DllImport报错

namespace NbtRobot
{

    public class Nrc
    {
        private const String NBT_CON_DLL_NAME = "nrc_host.dll";

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern bool connect_robot([MarshalAs(UnmanagedType.LPStr)]string ip);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern bool connection_status();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern bool servo_power_on();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void servo_power_off();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void get_current_position([MarshalAs(UnmanagedType.LPArray,SizeConst = 6)] double[] pos, int coord); 

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void get_current_sync_position([MarshalAs(UnmanagedType.LPArray, SizeConst = 5)] double[] pos);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_movj([MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_movl([MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_movc([MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos1, [MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos2, [MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos3, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_movca([MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos1, [MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos2, [MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] pos3, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_movs(int size,[MarshalAs(UnmanagedType.LPArray, SizeConst = 60)] double[][] pos, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_extra_movj([MarshalAs(UnmanagedType.LPArray, SizeConst = 12)] double[] pos, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_extra_movl([MarshalAs(UnmanagedType.LPArray, SizeConst = 12)] double[] pos, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void robot_extra_movc([MarshalAs(UnmanagedType.LPArray, SizeConst = 12)] double[] pos1, [MarshalAs(UnmanagedType.LPArray, SizeConst = 12)] double[] pos2, [MarshalAs(UnmanagedType.LPArray, SizeConst = 12)] double[] pos3, int vel, int coord);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void continue_run();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void start_jogging(int axis ,bool dir);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void stop_jogging(int axis);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern int get_robot_running_state();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_servo_state(int state);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern int get_servo_state();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void clear_servo_error();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern bool set_axis_zero(int axis);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern double get_global_variant(string varName);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_global_variant(string varName, double varValue);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_jogging_speed(int speed);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern int get_jogging_speed();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_dout(int port, int value);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_aout(int port, double value);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void get_dout(double[] dout);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void get_din(double[] din);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void get_aout(double[] aout);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void get_ain(double[] ain);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern int get_current_mode();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_current_mode(int mode);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern int get_current_coord();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_current_coord(int coord);

        [DllImport(NBT_CON_DLL_NAME, EntryPoint = "show_log", CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr show_log();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void upload_job(); 

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void download_job();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void delete_job(string job);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void open_job(string job);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void step_job(string job,int line);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern int run_job(string job);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void pause_job();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void continue_job();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_runs(int num);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void ask_four_point([MarshalAs(UnmanagedType.LPArray, SizeConst = 9)] double[] result);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void four_point_mark(int point, int status);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void four_point_calculation(double L1, double L2, [MarshalAs(UnmanagedType.LPArray, SizeConst = 5)] double[] result);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern bool result_for_DH();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void continuous_motion_mode(int on);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void send_continuous_motion_queue([In,Out] [MarshalAs(UnmanagedType.LPArray, SizeConst = 5)] cmdPara[] cmd , int size);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void continuous_motion_start();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void continuous_motion_suspend();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void continuous_motion_stop();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void get_single_cycle([MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] single_cycle);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern void set_zero_pos_shift(int axis, double shift);

        [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.Cdecl)] public delegate void CALLBACK(IntPtr msg);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Unicode)]
        public static extern void setErrorHandle([MarshalAs(UnmanagedType.FunctionPtr)] CALLBACK callback);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Unicode)]
        public static extern void switch_tool_hand(int tagetTool);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Unicode)]
        public static extern int get_current_tool_hand();

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Unicode)]
        public static extern void set_tool_hand_param(int toolNum, [MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] toolparam);

        [DllImport(NBT_CON_DLL_NAME, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Unicode)]
        public static extern void query_tool_hand_param(int tagetTool, [MarshalAs(UnmanagedType.LPArray, SizeConst = 6)] double[] toolparam);

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct cmdPara
        {
            public enum Type
            {
                MOVJ = 1, MOVL, MOVC, MOVS, MOVCA
                     , ARCON, ARCOFF, SEARCH_START, SEARCH_STATIC
            };
            public double m_velocity;
            public double m_acc;
            public double m_dec;
            public double m_pl;
            public int m_spin;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 7)]
            public double[] m_coord;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 7)]
            public double[] m_position;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 5)]
            public double[] m_syncPosition;

            public int m_arcParameterID;

            public int start_searchID;

            public int start_searchSenseType;

            public int static_searchID;
            public int static_searchTableID;
            public string static_positionOutID;
            public double static_searchTableDelay;     

            public Type cmdType;

        }
    }
}
